{{ NordicPlusPlusDemo110409i

  This demo uses two nRF24L01+ modules to
  communicate.  Right now only one of the
  modules transmits and the other receives.
  This code is mainly base on C code posted
  by Leon in the Propeller Forum.
  
  
  110404a change to use older Nordic as aux.
  4a didn't work.
  7a move code from Nordic object to this
  top object to make file matainence easier.
  7d fix problem with reading packet.  7d works.
  8a change transmitString method (and others)
  to point to string.  8b change packet length
  to 32 bytes.  8b works.  c make payload size
  a variable.  c works.  d try enhanced ShockBurst.
  9a take out timing delays, they aren't needed.
  9b use SPI_Asm.  b doesn't work.  c doesn't
  work.  d works using old SPI method.  e read
  SPI with new method.  e works.  f use Asm to
  write SPI commands as well.  f works.
  g remove delay in PASM code of SPI object.
  g works.  h move Nordic methods to separate
  object.  i work.
  
}}
'' Adapted from:
''****************************************
''*  nFR24L01 Demo                       *
''*  Authors: Nikita Kareev              *
''   The above demo didn't work
''   Much of this code is based on C code by Leon
 
CON
  _clkmode = xtal1 + pll16x                           
  _xinfreq = 5_000_000
    
CON

  'Pins
  SPI_SCK = 13 
  SPI_MISO = 15
  SPI_MOSI = 14
  SPI_CSN = 12     
  SPI_CE = 11
  SPI_IRQ = 16

CON

  rfrx_led          = 1 '25       'set low to turn LED on
  rftx_led          = 0 '24        'set low to turn LED on
     
  SPI_CE1 = 5
  SPI_CSN1 = 6     
  SPI_SCK1 = 7 
  SPI_MOSI1 = 8
  SPI_MISO1 = 9
  SPI_IRQ1 = 10

  ' Device enumeration (future use)
  #1, _NordicA, _NordicBaseStation, _NordicInputDevice, _NordicD

  ' modes
  #0, _RxMode, _TxMode

  _LargeBufferSize = 64
  _LargestPayloadSize = 32
  _DefaultPayloadSize = _LargestPayloadSize

VAR

  long nordicStack[100] 

  byte SpiIrq[2]
  byte payloadSize
  byte globalPayload0[_LargestPayloadSize + 1] ' Add 1 so a terminating zero may be added if desired.
  byte globalPayload1[_LargestPayloadSize + 1] ' This buffer doesn't get used.  It's here just in case
                                               ' the second Nordic device picks up a transmission.

OBJ   

  Debug : "FullDuplexSerialPlus"   
  Nordic[2] : "dwd_nRF24L01Alpha01"                 'Nordic nRF24L01
  
PUB Demo | localIndex 


  Debug.start(31, 30, 0, 57600)
  waitcnt(clkfreq * 2 + cnt)
  Debug.str(String("Start of Nordic Demo", 13))
  
  SpiIrq[0] := SPI_IRQ
  SpiIrq[1] := SPI_IRQ1
  
  'Initialize Nordic nRF24L01
  payloadSize := _DefaultPayloadSize 
  Nordic[0].Init(SPI_SCK, SPI_MISO, SPI_MOSI, SPI_CSN, SPI_CE, _RxMode, payloadSize)
               '(sck, miso, mosi, csn, ce, _mode, _payloadSize)
  Debug.str(String("Nordic 0 Started", 13))
  waitcnt(clkfreq + cnt)
  'Set IRQ pin states 
  dira[SpiIrq[0]]~
  dira[rfrx_led]~~
  
  
  result := cognew(secondNordic, @nordicStack) 
  Debug.str(String("Receiver configured. Waiting for packets...", 13))
  Debug.str(String("Second Nordic Module monitored on cog #"))
  Debug.dec(result)
  Debug.tx(13) 
  waitcnt(clkfreq /2 + cnt)
  Debug.str(String("Receiver configured. Waiting for packets...", 13))
  repeat
    if ina[SpiIrq[0]]  == 0 'Wait for incoming data
      'We have some data
      outa[rfrx_led]~~
      Nordic[0].ReadPayload(@globalPayload0)
      Debug.str(String("Data received: "))
      repeat localIndex from 0 to payloadSize - 1
        if globalPayload0[localIndex] => 32 and globalPayload0[localIndex] =< 127
          Debug.tx(globalPayload0[localIndex])
        else
          Debug.hex(globalPayload0[localIndex], 2)
      Debug.tx(13)
      outa[rfrx_led]~
      
PUB SecondNordic | localIndex, localCharacter, localBufferIndex, loopCount

  'Initialize Nordic nRF24L01
  result := Nordic[1].Init(SPI_SCK1, SPI_MISO1, SPI_MOSI1, SPI_CSN1, SPI_CE1, _TxMode, payloadSize)
  waitcnt(clkfreq / 4 + cnt)
  Debug.str(String("Second SPI started on cog #"))
  Debug.dec(result)
  Debug.tx(13)
  'Set IRQ pin state 
  dira[SpiIrq[1]]~

  dira[rftx_led]~~
  
  localBufferIndex := 0
  loopCount := 0
  repeat
    waitcnt((clkfreq / 2) * 3 + cnt)
    outa[rftx_led]~~
    if loopCount // 2 == 0
      Nordic[1].TransmitString(@test1)
    else
      Nordic[1].TransmitString(@test2) 
    waitcnt(clkfreq / 2 + cnt)
    outa[rftx_led]~
    loopCount++
    if ina[SpiIrq[1]]  == 0 'Wait for incoming data
      'We have some data
      Nordic[1].ReadPayload(@globalPayload1)
      Debug.str(String("Data received 1 : "))
      ' This could cause problems is both devices received at the same time.
      ' But for now, nothing tranmits to this device.
      repeat localIndex from 0 to payloadSize - 1
        if globalPayload1[localIndex] => 32 and globalPayload1[localIndex] =< 127
          Debug.tx(globalPayload1[localIndex])
        else
          Debug.hex(globalPayload1[localIndex], 2)
      Debug.tx(13)
      
DAT
                         '1         2         3
               '01234567890123456789012345678901
test1     byte "Kill all humans. Robots forever!", 0

                         '1         2         3
               '01234567890123456789012345678901
test2     byte "Oh no! The humans are too strong", 0
        